<?php

namespace app\admin\controller;

use app\common\model\bgf\Config;

class Bgfconfig extends Botbase
{
    /**
     * @var Config
     */
    protected $model;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->model = new Config();
    }

    /**
     * 设置
     * @return mixed
     * @throws \think\Exception
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function index(){
        $tip = "关闭应用，则所有代理商都无法使用这个应用";
        $settings = $this->model->getConf(['admin_id' => $this->adminInfo['id']]);
        if(empty($settings)){
            $settings = [
                'switch' => 0,
                'userid' => 'userId'
            ];
        }
        if(!empty($settings['groups'])){
            $settings['groups'] = explode(',', $settings['groups']);
        }else{
            $settings['groups'] = [];
        }

        $builder = new FormBuilder();
        $builder->setPostUrl(url('savePost'))
            ->setTip($tip)
            ->addFormItem('switch', 'radio', '开启', '是否开启', [1=>'是', 0 => '否'], 'required')
            ->addFormItem('groups', 'chosen_multi', '商品采集群', '商品采集群', $this->getMembers(['type' => \app\constants\Bot::GROUP]), 'required')
            ->addFormItem('userid', 'text', '用户id名', '页面参数的用户ID名', [], 'required')
            ->setFormData($settings);
        return $builder->show();
    }

    public function savePost($jump_to = '/undefined', $data = [])
    {
        $jump_to = url('index');
        $post_data = input('post.');
        unset($post_data['__token__']);
        foreach ($post_data as $k => $v){
            if($config = $this->model->getOneByMap(['admin_id' => $this->adminInfo['id'], 'key' => $k],  true, true)){
                $this->model->updateOne(['id' => $config['id'], 'value' => $v]);
            }else{
                $this->model->addOne([
                    'admin_id' => $this->adminInfo['id'],
                    'key' => $k,
                    'value'=> $v
                ]);
            }
        }
        $this->model->getConf(['admin_id' => $this->adminInfo['id']], '', true);
        $this->success('数据保存成功', $jump_to);
    }
}